- Code, UI, and other stuff by me
- Model, Textures and Animations by Drag
- Sounds by Violet Chaolan


Feedback and bug reports are welcome, feel free to join my [discord server](https://discord.gg/jXGFN4k), I also do beta testing for new features and content there.

Fully compatible with multiplayer with no errors or desync as long as everyone has the mod installed. If you happen to find an issue, please let me know (preferably with the console logs from all players involved)

Note that the `???` locked skills are not possible to unlock, they are only partly complete currently. Their unlock conditions will be added in future updates. 

## Showcase

[![Showcase video](https://img.youtube.com/vi/Au6AzQewzQg/0.jpg)](https://youtu.be/Au6AzQewzQg)

## Overview
### New in this update (1.0.3):
```
    Bugfixes:
- Fixed reload UI not working on artifact hidden stage.
```

### Installation
- Unzip the Sniper folder to `[RoR2InstallFolder]/BepInEx/Plugins/Sniper`
- (Create the sniper folder if it isn't there)
- If you run into issues, try using [r2modman](https://thunderstore.io/package/ebkr/r2modman/) by ebkr
- To uninstall, simply delete the Sniper folder from `[RoR2InstallFolder]/BepInEx/Plugins/`

### General info
Sniper is a long ranged, single-target dps that incorperates elements of an assassin to stay alive.

They excel at taking down bosses and high priority targets but struggle against larger groups of weak enemies.

### Skills
See the in game descriptions, maintaining two copies of all the information tends to just result in a mess.

## FAQ
### I can't fire my primary!
Most likely a conflict with another mod, in particular skills++ is known to cause this issue.

### What does '1.0x' mean?
Any skill with that type of notation in its description means that a multiplier is being layered on top of another skill, usually your primary. So, for example, say an attack from your primary would deal 50 damage. If your ammo type has a 2.0x multiplier, that attack would be multiplied by 2.0, and deal 100 damage.

### How do I use this in multiplayer?
As with all custom characters, everyone must have the mod installed. If you still run into issues, verify that everyone has the exact same installed mods, including versions. There is usually some level of leeway here, but when in doubt that should be the first thing you try.

### How do I unlock the skills?
For now, they are not unlockable. The locked skills are still WIP. 

### Can I use this on console?
Unfortunately no, there currently is no modding for console RoR2. This would require complete official mod support from Hopoo for both PC and consoles, which is no small task.

### How do I zoom in on controller?
Unfortunately, you can't do it just yet. I'm working on a fix for this. You can still use secondary, you just can't scroll to increase zoom and enter scoped.

## Known Issues
### Incompatibilities
If you find any, please let me know.
- Skills++ (Unfortunately nothing I can do for this one either. There are multiple layers of issues that need resolving.)
- Achievement Loader (Nothing I can do on my end for this one, however, the mod does still work, you just need to be careful not to select one of the WIP skills that it forcibly unlocks as there isn't a skill behind it)

### Bugs/issues
Again, if you find any let me know.
- No death animation.
- Does not work with vengance artifact (May be better this way. Aimbot hitscan long range AI does not sound like fun)
- No item or equipment displays.
- Crowdfunder and Milky Chrysalis do not currently work due to the above.
- Untested interactions with Visions of Heresy...

## Changelog
###1.0.3
```
    Bugfixes:
- Fixed reload UI not working on artifact hidden stage.
```

###1.0.2
```
    Adjustments:
- The impact of attack speed on the reload bar is now smoother
    Essentially, when your attack speed changes, the bar move speed gradually shifts over half a second to that new speed.
    This should make items like berserkers, predatory, war horn, and tonic less jarring upon activation.
    While this does mean that you don't get the full benefits of conditional attack speed items immediately, you do get to keep them a bit longer because of the falloff time.

    Bugfixes:
- Fixed various UI issues for clients in multiplayer
```

###1.0.1:
```    
    Adjustments:
-Quickscope cooldown: 4s -> 5s
    Quickscope was allowing too many successive shots without items.

-Steady aim max damage: 6.5x -> 6x
-Steady aim min damage: 1.5x -> 1.25x
-Steady aim delay: 0.35s -> 0.5s
    Steady aim was a bit too strong with backup mags

-Decoy cooldown: 18s -> 12s
-Decoy stealth duration: 2s -> 2.5s
    Decoy was not up enough to do its job of keeping you safe

-Precise aim now also gives +1% crit chance per character level
    Precise aim relied on items too much.

-Remade scope UI and added a new shader for it
-Greatly reduced size of reload bar
-Moved reload bar to upwards
-Reload bar now has some transparency
-Charge indicator outline thickness reduced
-Improved perfect reload sound
-Improved some ability descriptions
-Slimmed down crosshair

    Bugfixes:
-Steady aim properly restarts delay between shots 
-Fixed issues with ricochet sounds on fmj
-Fixed ricochet being limited to 2 bounces
-Fixed reload bar hiding on death
-Fixed reload bar being visible on other characters
-Corrected version number
-Fixed reload bar not being visible after revive
-Fixed issue with quickscope not starting aim animations
```
###1.0.0:
```
-First release
```